#include <array>

#include "delay.h"
#include "platform/hal.h"

enum {
    PIN_NUMBER_LED_1 = 17,
    PIN_NUMBER_LED_2 = 18,
    PIN_NUMBER_LED_3 = 19,
    PIN_NUMBER_LED_4 = 20
};

hal::Gpio led_1(PIN_NUMBER_LED_1);
hal::Gpio led_2(PIN_NUMBER_LED_2);
hal::Gpio led_3(PIN_NUMBER_LED_3);
hal::Gpio led_4(PIN_NUMBER_LED_4);

std::array<hal::Gpio *, 4> leds = {&led_1, &led_2, &led_3, &led_4};

int main(void)
{
    while(true) {
        for(auto it = std::begin(leds); it != std::end(leds); ++it) {
            hal::Gpio * tmp = *it;
            tmp->toggle();
            delay_ms(500);
        }
    }
    return 0;
}
